6d7c6099eb16a5454fb195bc8ff97173b5de3831
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 90-strpbrk
138 91-fseek
139 92-stat
140 93-fread-fwrite
141 "
142
143 # 90: needs GNU, fails for mescc, passes for tcc
144 broken="$broken
145 7s-struct-short
146 "
147
148 # gcc not supported
149 CC=
150 set +e
151 expect=$(echo $broken | wc -w)
152 pass=0
153 fail=0
154 total=0
155 for t in $tests; do
156     if [ -z "${t/[012][0-9]-*/}" ]; then
157         LIBC=c-mini
158         MESCCLIBS="-l c-mini"
159     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
160         LIBC=c+tcc
161         MESCCLIBS="-l c+tcc"
162     elif [ -z "${t/9[0-9]-*/}" ]; then
163         LIBC=c+gnu
164         MESCCLIBS="-l c+gnu"
165     else
166         LIBC=c
167         MESCCLIBS=
168     fi
169     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
170     r=$?
171     total=$((total+1))
172     if [ $r = 0 ]; then
173         echo $t: [OK]
174         pass=$((pass+1))
175     else
176         echo $t: [FAIL]
177         fail=$((fail+1))
178     fi
179 done
180
181 tests="
182 00_assignment
183 01_comment
184 02_printf
185 03_struct
186 04_for
187 05_array
188 06_case
189 07_function
190 08_while
191 09_do_while
192
193 10_pointer
194 11_precedence
195 12_hashdefine
196 13_integer_literals
197 14_if
198 15_recursion
199 16_nesting
200 17_enum
201 18_include
202 19_pointer_arithmetic
203
204 20_pointer_comparison
205 21_char_array
206 22_floating_point
207 23_type_coercion
208 24_math_library
209 25_quicksort
210 26_character_constants
211 27_sizeof
212 28_strings
213 29_array_address
214
215 30_hanoi
216 31_args
217 32_led
218 33_ternary_op
219 34_array_assignment
220 35_sizeof
221 36_array_initialisers
222 37_sprintf
223 38_multiple_array_index
224 39_typedef
225
226 40_stdio
227 41_hashif
228 42_function_pointer
229 43_void_param
230 44_scoped_declarations
231 45_empty_for
232 47_switch_return
233 48_nested_break
234 49_bracket_evaluation
235
236 50_logical_second_arg
237 51_static
238 52_unnamed_enum
239 54_goto
240 55_lshift_type
241 "
242
243 broken="$broken
244 18_include
245
246 22_floating_point
247 23_type_coercion
248 24_math_library
249 26_character_constants
250 27_sizeof
251 28_strings
252
253 34_array_assignment
254 39_typedef
255
256 40_stdio
257 42_function_pointer
258 49_bracket_evaluation
259 55_lshift_type
260 "
261
262 #22_floating_point       ; float
263 #23_type_coercion        ; float
264 #24_math_library         ; float
265 #27_sizeof               ; float
266 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
267 #30_hanoi                ; fails with GCC
268 #34_array_assignment     ; fails with GCC
269 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
270
271 #40_stdio                ; f* functions
272 #42_function_pointer     ; f* functions
273 #49_bracket_evaluation   ; float
274
275 LIBC=c+gnu
276 MESCCLIBS="-l c+gnu"
277
278 expect=$(echo $broken | wc -w)
279 ARGS="arg1 arg2 arg3 arg4 arg5"
280 export ARGS
281 for t in $tests; do
282     if [ ! -f scaffold/tinycc/"$t.c" ]; then
283         echo ' [SKIP]'
284         continue;
285     fi
286     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
287     r=$?
288     total=$((total+1))
289     if [ $r = 0 ]; then
290         echo $t: [OK]
291         pass=$((pass+1))
292     else
293         echo $t: [FAIL]
294         fail=$((fail+1))
295     fi
296 done
297 [ $expect != 0 ] && echo "expect: $expect"
298 [ $fail != 0 ] && echo "failed: $fail"
299 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
300 echo "passed: $pass"
301 echo "total:  $total"
302 if [ $fail != 0 -a $fail -gt $expect ]; then
303     echo FAILED: $fail/$total
304     exit 1
305 elif [ $fail != 0 ]; then
306     echo PASS: $pass/$total
307 else
308     echo PASS: $total
309 fi